# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl 1.t'

#########################

# $Header: /SPACE/cycle/cvs/2004/moi-perl/MOI/Error/t/1.t,v 1.3 2003-06-30 09:51:34 leo Exp $
#
# This test is derived from t/01throw.t of the Error-distribution
#                                  by Graham Barr <gbarr@ti.com>.
#
# - Richard Leopold <moi-perl@leo.0n3.org>
##

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 6;
BEGIN { use_ok('MOI::Error', ':try') };

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

try {
	ok( 1, 'try test' );
};


try {
	throw MOI::Error::Simple("ERROR", 2);
	ok( 0, 'throw test' );
}
catch MOI::Error::Simple with {
	my $err = shift;
	ok( $err->value == 2,      "error value test" );
	ok( $err->text eq 'ERROR', "error text test" );
}
finally {
	ok(1, 'finally test');
};

my $pri = prior MOI::Error;
ok( $pri->value == 2, "prior test" );

# bye
