# $Header: /SPACE/cycle/cvs/2004/moi-perl/MOI/Error/t/2.t,v 1.3 2003-06-30 09:51:34 leo Exp $
#
# This test is derived from t/02order.t of the Error-distribution 
#                                   by Graham Barr <gbarr@ti.com>.
#
# - Richard Leopold <moi-perl@leo.0n3.org>
##

# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl 1.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 6;
BEGIN { use_ok('MOI::Error', ':try') };

#########################

@MOI::Error::Fatal::ISA = qw(MOI::Error);

$num = try {
	try {
		try {
			throw MOI::Error::Simple('ERROR');
		}
		catch MOI::Error::Simple with {
			my $err = shift;
			ok(1);
			throw MOI::Error::Fatal(-value => 4);
			ok(0);
		}
		catch MOI::Error::Fatal with {
			exit(1);
		}
		finally {
			ok(1);
		};
	} 
	finally {
		ok(1);
	};
}

catch MOI::Error::Fatal with {
	my $err = shift;
	my $more = shift;
	$$more = 1;
	
	ok(0+$err == 4);
}
catch MOI::Error::Fatal with {
	my $err = shift;
	ok(1+$err == 5);
	return 6;
}
catch MOI::Error::Fatal with {
	my $err = shift;
	ok (0) and diag('should never reached this point');
};

# done
